// #autoload
// #name = vehiclebinds
// #category = ilys' Scripts
// #version = 2.0
// #date = January 28, 2003
// #status = release
// #author = ilys
// #warrior = ilys
// #credits = Kirb, Doc^Holliday, God, Jesus and the munchkins from no.37
// #config = vehiclebindsOptions

if(!isObject(vehiclebindsShrikePilotMap))
	new ActionMap(vehiclebindsShrikePilotMap);
if(!isObject(vehiclebindsBomberPilotMap))
	new ActionMap(vehiclebindsBomberPilotMap);
if(!isObject(vehiclebindsBombardierMap))
	new ActionMap(vehiclebindsBombardierMap);
if(!isObject(vehiclebindshapcPilotMap))
	new ActionMap(vehiclebindshapcPilotMap);
if(!isObject(vehiclebindsTankPilotMap))
	new ActionMap(vehiclebindsTankPilotMap);
if(!isObject(vehiclebindsTankGunnerMap))
	new ActionMap(vehiclebindsTankGunnerMap);
if(!isObject(vehiclebindsBikePilotMap))
	new ActionMap(vehiclebindsBikePilotMap);
if(!isObject(vehiclebindsMPBPilotMap))
	new ActionMap(vehiclebindsMPBPilotMap);

exec("prefs/vehiclebinds.cs");

$shrikepilotbinds = 0;
$bomberpilotbinds = 0;
$bombardierbinds = 0;
$tankpilotbinds = 0;
$tankgunnerbinds = 0;
$bikepilotbinds = 0;
$hapcpilotbinds = 0;
$mpbpilotbinds = 0;

package vehiclebinds
{
function clientCmdVehicleDismount()
{
	parent::clientCmdVehicleDismount();
	vehiclebindsShrikePilotMap.pop();
	vehiclebindsBomberPilotMap.pop();
	vehiclebindsBombardierMap.pop();
	vehiclebindshapcPilotMap.pop();
	vehiclebindsTankPilotMap.pop();
	vehiclebindsTankGunnerMap.pop();
	vehiclebindsBikePilotMap.pop();
	vehiclebindsMPBPilotMap.pop();
}

function ClientCmdDisplayHuds()
{
	parent::clientCmdDisplayHuds();
	if($HudMode $= "Pilot")
	{
		if($HudModeType $= "Shrike" && $HudModeNode $= "0")
			vehiclebindsShrikePilotMap.push();
		else if($HudModeType $= "Bomber" && $HudModeNode $= "0")
			vehiclebindsBomberPilotMap.push();
		else if($HudModeType $= "Bomber" && $HudModeNode $= "1")
			vehiclebindsBombardierMap.pop();
		else if($HudModeType $= "HAPC" && $HudModeNode $= "0")
			vehiclebindshapcPilotMap.push();
		else if ($HudModeType $= "Assault" && $HudModeNode $= "0")
			vehiclebindsTankPilotMap.push();
		else if ($HudModeType $= "Assault" && $HudModeNode $= "1")
			vehiclebindsTankGunnerMap.push();
		else if ($HudModeType $= "Hoverbike" && $HudModeNode $= "0")
			vehiclebindsBikePilotMap.push();
		else if ($HudModeType $= "MPB" && $HudModeNode $= "0")
			vehiclebindsMPBPilotMap.push();
	}
}
};
activatePackage(vehiclebinds);

function vehiclebindsSavePrefs(%this)
{
	vehiclebindsShrikePilotMap.save("prefs/vehiclebinds.cs", false);
	vehiclebindsBomberPilotMap.save("prefs/vehiclebinds.cs", true);
	vehiclebindsBombardierMap.save("prefs/vehiclebinds.cs", true);
	vehiclebindsTankPilotMap.save("prefs/vehiclebinds.cs", true);
	vehiclebindsTankGunnerMap.save("prefs/vehiclebinds.cs", true);
	vehiclebindsBikePilotMap.save("prefs/vehiclebinds.cs", true);
	vehiclebindsHAPCPilotMap.save("prefs/vehiclebinds.cs", true);
	vehiclebindsMPBPilotMap.save("prefs/vehiclebinds.cs", true);

	$shrikepilotbinds = 0;
	$bomberpilotbinds = 0;
	$bombardierbinds = 0;
	$tankpilotbinds = 0;
	$tankgunnerbinds = 0;
	$bikepilotbinds = 0;
	$hapcpilotbinds = 0;
	$mpbpilotbinds = 0;
}

function vehiclebindsBuildFullMapString(%index)
{
	%name       = $RemapName[%index];
	%cmd        = $RemapCmd[%index];

	if ($shrikepilotbinds)
		%temp = vehiclebindsShrikePilotMap.getBinding(%cmd);
	else if ($bomberpilotbinds)
		%temp = vehiclebindsBomberPilotMap.getBinding(%cmd);
	else if ($bombardierbinds)
		%temp = vehiclebindsBombardierMap.getBinding(%cmd);
	else if ($tankpilotbinds)
		%temp = vehiclebindsTankPilotMap.getBinding(%cmd);
	else if ($tankgunnerbinds)
		%temp = vehiclebindsTankGunnerMap.getBinding(%cmd);
	else if ($bikepilotbinds)
		%temp = vehiclebindsBikePilotMap.getBinding(%cmd);
	else if ($hapcpilotbinds)
		%temp = vehiclebindshapcPilotMap.getBinding(%cmd);
	else if ($mpbpilotbinds)
		%temp = vehiclebindsMPBPilotMap.getBinding(%cmd);

	%device = getField(%temp, 0);
	%object = getField(%temp, 1);

	if(%device !$= "" && %object !$= "")
		%mapString = getMapDisplayName(%device, %object);
	else
		%mapString = "";

	return(%name TAB %mapString);
}

function vehiclebindsChangeVehicleBind(%device, %action, %oldIndex, %newIndex)
{
	if ($shrikepilotbinds)
		vehiclebindsShrikePilotMap.bind(%device, %action, $RemapCmd[%newIndex]);
	else if ($bomberpilotbinds)
		vehiclebindsBomberPilotMap.bind(%device, %action, $RemapCmd[%newIndex]);
	else if ($bombardierbinds)
		vehiclebindsBombardierMap.bind(%device, %action, $RemapCmd[%newIndex]);
	else if ($tankpilotbinds)
		vehiclebindsTankPilotMap.bind(%device, %action, $RemapCmd[%newIndex]);
	else if ($tankgunnerbinds)
		vehiclebindsTankGunnerMap.bind(%device, %action, $RemapCmd[%newIndex]);
	else if ($bikepilotbinds)
		vehiclebindsBikePilotMap.bind(%device, %action, $RemapCmd[%newIndex]);
	else if ($hapcpilotbinds)
		vehiclebindshapcPilotMap.bind(%device, %action, $RemapCmd[%newIndex]);
	else if ($mpbpilotbinds)
		vehiclebindsMPBPilotMap.bind(%device, %action, $RemapCmd[%newIndex]);

	vehiclebindsvehicleControls.setRowById(%oldIndex, vehiclebindsBuildFullMapString(%oldIndex));
	vehiclebindsvehicleControls.setRowById(%newIndex, vehiclebindsBuildFullMapString(%newIndex));
}

function vehiclebindsOptionsRemapDlg::onWake(%this)
{
	$enableDirectInput = "1";
	activateDirectInput();
}

function vehiclebindsOptionsRemapDlg::onSleep(%this)
{
	$enableDirectInput = "1";
	deactivateDirectInput();
}

function vehiclebindsvehicleControls::fillList(%this)
{
   %this.clear();
   for(%i = 0; %i < $RemapCount; %i++)
      %this.addRow(%i, vehiclebindsBuildFullMapString(%i));
}

function vehiclebindsvehicleControls::onDeleteKey(%this, %index)
{
	if ($shrikepilotbinds)
		clearMapping(vehiclebindsShrikePilotMap, $RemapCmd[%index]);
	else if ($bomberpilotbinds)
		clearMapping(vehiclebindsBomberPilotMap, $RemapCmd[%index]);
	else if ($bombardierbinds)
		clearMapping(vehiclebindsBombardierMap, $RemapCmd[%index]);
	else if ($tankpilotbinds)
		clearMapping(vehiclebindsTankPilotMap, $RemapCmd[%index]);
	else if ($tankgunnerbinds)
		clearMapping(vehiclebindsTankGunnerMap, $RemapCmd[%index]);
	else if ($bikepilotbinds)
		clearMapping(vehiclebindsBikePilotMap, $RemapCmd[%index]);
	else if ($hapcpilotbinds)
		clearMapping(vehiclebindshapcPilotMap, $RemapCmd[%index]);
	else if ($mpbpilotbinds)
		clearMapping(vehiclebindsMPBPilotMap, $RemapCmd[%index]);

	%this.setRowById(%index, vehiclebindsBuildFullMapString(%index));
}

function vehiclebindsvehicleControls::doRemap(%this)
{
	%index = %this.getSelectedId();
	%name = $RemapName[%index];

	vehiclebindsremapFrame.setTitle("REMAP \"" @ %name @ "\"");
	vehiclebindsremapInputCtrl.index = %index;
	Canvas.pushDialog(vehiclebindsOptionsRemapDlg);
}

function vehiclebindsremapInputCtrl::onInputEvent(%this, %device, %action)
{
	Canvas.popDialog(vehiclebindsOptionsRemapDlg);

	if(%device $= "keyboard" && %action $= "escape")
		return;

	%cmd = $RemapCmd[%this.index];
	%name = $RemapName[%this.index];

	if ($shrikepilotbinds)
		%prevCmd = vehiclebindsShrikePilotMap.getCommand(%device, %action);
	else if ($bomberpilotbinds)
		%prevCmd = vehiclebindsBomberPilotMap.getCommand(%device, %action);
	else if ($bombardierbinds)
		%prevCmd = vehiclebindsBombardierMap.getCommand(%device, %action);
	else if ($tankpilotbinds)
		%prevCmd = vehiclebindsTankPilotMap.getCommand(%device, %action);
	else if ($tankgunnerbinds)
		%prevCmd = vehiclebindsTankGunnerMap.getCommand(%device, %action);
	else if ($bikepilotbinds)
		%prevCmd = vehiclebindsBikePilotMap.getCommand(%device, %action);
	else if ($hapcpilotbinds)
		%prevCmd = vehiclebindshapcPilotMap.getCommand(%device, %action);
	else if ($mpbpilotbinds)
		%prevCmd = vehiclebindsMPBPilotMap.getCommand(%device, %action);

	if(%prevCmd $= %cmd)
		return;

	if(%prevCmd $= "")
	{
		if ($shrikepilotbinds)
			vehiclebindsShrikePilotMap.bind(%device, %action, %cmd);
		else if ($bomberpilotbinds)
			vehiclebindsBomberPilotMap.bind(%device, %action, %cmd);
		else if ($bombardierbinds)
			vehiclebindsBombardierMap.bind(%device, %action, %cmd);
		else if ($tankpilotbinds)
			vehiclebindsTankPilotMap.bind(%device, %action, %cmd);
		else if ($tankgunnerbinds)
			vehiclebindsTankGunnerMap.bind(%device, %action, %cmd);
		else if ($bikepilotbinds)
			vehiclebindsBikePilotMap.bind(%device, %action, %cmd);
		else if ($hapcpilotbinds)
			vehiclebindshapcPilotMap.bind(%device, %action, %cmd);
		else if ($mpbpilotbinds)
			vehiclebindsMPBPilotMap.bind(%device, %action, %cmd);

		vehiclebindsvehicleControls.setRowById(%this.index, vehiclebindsBuildFullMapString(%this.index));
	}
	else
	{
		%mapName = getMapDisplayName(%device, %action);
		%prevCmdIndex = findRemapCmdIndex(%prevCmd);

		if(%prevCmdIndex == -1)
			MessageBoxOK("REMAP FAILED", "\"" @ %mapName @ "\" is already bound to a non-remappable command!");
		else
		{
			%prevCmdName = $RemapName[%prevCmdIndex];
			MessageBoxYesNo("WARNING","\"" @ %mapName @ "\" is already bound to \"" @ %prevCmdName @"\"!\nDo you want to undo this mapping?","vehiclebindsChangeVehicleBind(" @ %device @ ", \"" @ %action @ "\", " @ %prevCmdIndex @ ", " @ %this.index @ ");","");
		}
	}
}

new GuiControl(vehiclebindsOptions) {
	profile = "GuiDefaultProfile";
//	horizSizing = "right";
//	vertSizing = "bottom";
	horizSizing = "center";
	vertSizing = "center";
//	position = "0 20";
	position = "0 0";
	extent = "232 295";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 20";
		extent = "232 295";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Vehicle Binds II";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 30";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$shrikepilotbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "Shrike Binds";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 60";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$bomberpilotbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "Bomber Pilot Binds";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 90";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$bombardierbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "Bombardier Binds";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 120";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$tankpilotbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "Tank Pilot Binds";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 150";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$tankgunnerbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "Gunner Binds";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 180";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$bikepilotbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "Gravcycle Binds";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 210";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$hapcpilotbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "HAPC Pilot Binds";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "16 240";
			extent = "200 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$mpbpilotbinds = 1; Canvas.pushDialog(vehiclebindsOptionsControlsDlg); OptionsDlg::onWake(); vehiclebindsvehicleControls.fillList();";
			helpTag = "0";
			text = "MPB Binds";
			simpleStyle = "0";
		};
	};
};

new GuiControl(vehiclebindsOptionsControlsDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "035 305";
	visible = "1";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 20";
		extent = "305 305";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Controls Override";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

	new ShellBitmapButton() {
		profile = "ShellButtonProfile";
		position = "110 252";
		extent = "82 38";
		visible = "1";
		command = "vehiclebindsSavePrefs(); Canvas.popDialog(vehiclebindsOptionsControlsDlg);";
		text = "CLOSE";
	};

	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		position = "30 40";
		extent = "250 210";
		visible = "1";

		// control list
		new ShellScrollCtrl() {
			profile = "NewScrollCtrlProfile";
			position = "0 0";
			extent = "250 210";
			visible = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			childMargin = "0 2";

			new GuiScrollContentCtrl() {
				profile = "GuiDefaultProfile";
				position = "0 0";
				visible = "1";

				new ShellTextList(vehiclebindsvehicleControls) {
					profile = "ShellTextArrayProfile";
					position = "0 0";
					visible = "1";
					altCommand = "vehiclebindsvehicleControls.doRemap();";
					columns = "2 150";
				};
			};
		};
	};
	};
};

new GuiControl(vehiclebindsOptionsRemapDlg) {
	profile = "DlgBackProfile";
	position = "0 0";
	extent = "640 480";
	visible = "1";
	hideCursor = "1";

	new ShellPaneCtrl(vehiclebindsremapFrame) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "71 172";
		extent = "498 126";
		visible = "1";

		new GuiMLTextCtrl(vehiclebindsremapText) {
			profile = "ShellMediumTextProfile";
			position = "49 47";
			extent = "400 18";
			visible = "1";
			lineSpacing = "2";
		};

		new GuiInputCtrl(vehiclebindsremapInputCtrl) {
			profile = "GuiInputCtrlProfile";
			position = "0 0";
			visible = "1";
		};
	};
};

vehiclebindsremapText.setText("<just:center>Press a key or button to assign it to this action" NL "or " @ "Esc to cancel...");